// jQuery関連のライブラリ
google.load("jquery", "1");
google.load("jqueryui", "1");

// ローカルストレージ
var storage = localStorage;

// 保存時のキー
var savekey = "note.js";

// コンソール部の制御関数群
function clear() {
	$("#console").val("");
}

function print(msg) {
	var con = $("#console");
	con.val(con.val() + msg);
}

function println(msg) {
	var con = $("#console");
	con.val(con.val() + (msg + "\n"));
}

// ステータス表示
function status(msg) {
	$("#status").html(msg);
}

function execute(prg) {
	try {
		status("Execute.");
		eval(prg);
		status("Done.");

	} catch (e) {
		status("Error :" + e.message + " (line " + e.lineNumber + ")");
	}
}

//
// textarea のカーソル位置にテキストを挿入する
// <http://d.hatena.ne.jp/spitfire_tree/20131209/1386575758>
//
function insertAtCaret(target, str) {
	var obj = $(target);
	obj.focus();
	if(navigator.userAgent.match(/MSIE/)) {
		var r = document.selection.createRange();
		r.text = str;
		r.select();
	} else {
		var s = obj.val();
		var p = obj.get(0).selectionStart;
		var np = p + str.length;
		obj.val(s.substr(0, p) + str + s.substr(p));
		obj.get(0).setSelectionRange(np, np);
	}
}

//
// JavaScriptで任意のテキストを任意のファイル名でダウンロードする
// <http://lostlinksearch.net/blog/2012/11/javascript%E3%81%A7%E4%BB%BB%E6%84%8F%E3%81%AE%E3%83%86%E3%82%AD%E3%82%B9%E3%83%88%E3%82%92%E4%BB%BB%E6%84%8F%E3%81%AE%E3%83%95%E3%82%A1%E3%82%A4%E3%83%AB%E5%90%8D%E3%81%A7%E3%83%80%E3%82%A6%E3%83%B3/>
//
// a.download + data:text/plain or Blob でテキストを保存したら改行がLFになった
// <http://7cc.hatenadiary.jp/entry/save_text_blob>
//
function downloadAsFile(fileName, content) {
	var fname = prompt("Download File name", fileName) 
	if(!fname) return;

	if ( ~navigator.userAgent.indexOf("Windows") ) {
		content = content.replace(/\n/g, "\r\n").replace(/\r\r/g, "\r")
	}

	var blob = new Blob([content], { type: 'text/plain'});
	var url = window.URL || window.webkitURL;
	var blobURL = url.createObjectURL(blob);

	$("#dialog > a").attr("download", fname).attr("href", blobURL).text("Click Me");
};

//
// jQueryでファンクションキーやバックスペースキーを無効化する制御
// <http://jquery.nj-clucker.com/applied/ctrl_key_input_event_apply/>
//
function defaultKeyDown(event) {
	// クリックされたキーのコード
	var keyCode = event.keyCode;

	// Ctrlキーがクリックされたか (true or false)
	var ctrlClick = event.ctrlKey;

	// Altキーがクリックされたか (true or false)
	var altClick = event.altKey;

	// キーイベントが発生した対象のオブジェクト
	var obj = event.target;	// バックスペースキーを制御する

	if (keyCode == 8) {
		// テキストボックス／テキストエリアを制御する
		if ((obj.tagName == "INPUT" && obj.type == "TEXT")
			|| obj.tagName == "TEXTAREA") {
			// 入力できる場合は制御しない
			if (!obj.readOnly && !obj.disabled) {
				return true;
			}
		}
		return false;
	}
 
	// Alt + ←→を制御する
	if (altClick && (keyCode == 37 || keyCode == 39)) {
		return false;
	}
 
	// Ctrl + Nを制御する
	if (ctrlClick && keyCode == 78) {
		return false;
	}
}

// ファイルを読み切ってからイベントの設定
google.setOnLoadCallback(function() {
	// エディタ部分の文字列をそのまま実行
	$("button.run").click(function(){
		execute($("#editer").val());
	});

	// 保存した内容を読み込む
	$("button.load").click(function(){
		status("Load.");
		$("#editer").val(storage.getItem(savekey));
	});

	// ローカルストレージに保存
	$("button.save").click(function(){
		status("Save.");
		storage.setItem(savekey, $("#editer").val());
	});

	// コンソールの内容をダウンロード
	$("button.download").click(function(){
		status("Download.");
		downloadAsFile("console.txt", $("#console").val());
		$("#dialog").dialog({
			title: "Download",
			modal: true,
		});
	});

	// バックスペースキーなどを無効化する制御
	$(document).keydown(function(event){
		return defaultKeyDown(event);
	});

	// タブキーを入力に変換
	$("#editer").keydown(function(event){
		if (event.keyCode == 9) {
			insertAtCaret("#editer", "	");
			return false;
		} else {
			return defaultKeyDown(event);
		}
	});
});
